summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorMartin Pitt <martin.pitt@ubuntu.com>2009-05-10 22:48:11 +0200
committerMartin Pitt <martin.pitt@ubuntu.com>2009-05-10 22:48:11 +0200
commit4aad50770cd85a7a37743ffec26147bd0bc1cfea (patch)
tree4abf22fe3501047d056e89b3f9639f8784f0ad3e
parentda800c7ebbaf8d97cde9eb6d40d678ec92994077 (diff)
keymap: add check for valid names
Add keymap/check-keymaps.sh and run it in make check. This verifies that all key names in keymap/keymaps/* are known in the current <linux/input.h>.
-rw-r--r--keymap/Makefile.am1
-rwxr-xr-xkeymap/check-keymaps.sh16
2 files changed, 17 insertions, 0 deletions
diff --git a/keymap/Makefile.am b/keymap/Makefile.am
index 9974eb4..c7984ec 100644
--- a/keymap/Makefile.am
+++ b/keymap/Makefile.am
@@ -34,6 +34,7 @@ keymap_CPPFLAGS = $(AM_CPPFLAGS)
EXTRA_DIST=keymaps
BUILT_SOURCES = keys-from-name.h keys-to-name.h
CLEANFILES = keys.txt keys-from-name.gperf keys-from-name.h keys-to-name.h
+TESTS = check-keymaps.sh
#
# generation of keys-{from,to}-name.h from linux/input.h and gperf
diff --git a/keymap/check-keymaps.sh b/keymap/check-keymaps.sh
new file mode 100755
index 0000000..bb38378
--- /dev/null
+++ b/keymap/check-keymaps.sh
@@ -0,0 +1,16 @@
+#!/bin/bash
+# check that all key names in keymaps/* are known in <linux/input.h>
+
+KEYLIST=${srcdir:-.}/keys.txt
+
+[ -e "$KEYLIST" ] || {
+ echo "need $KEYLIST please build first" >&2
+ exit 1
+}
+
+missing=$(join -v 2 <(awk '{print tolower(substr($1,5))}' $KEYLIST | sort -u) <(awk '{print $2}' keymaps/*|sort -u))
+[ -z "$missing" ] || {
+ echo "ERROR: unknown key names in keymaps/*:" >&2
+ echo "$missing" >&2
+ exit 1
+}